Package org.springframework.scheduling.concurrent

# Class ForkJoinPoolFactoryBean

java.lang.Object
org.springframework.scheduling.concurrent.ForkJoinPoolFactoryBean

All Implemented Interfaces:
  `org.springframework.beans.factory.DisposableBean`, `org.springframework.beans.factory.FactoryBean<ForkJoinPool>`, `org.springframework.beans.factory.InitializingBean`

public class ForkJoinPoolFactoryBean extends Object implements org.springframework.beans.factory.FactoryBean<ForkJoinPool>, org.springframework.beans.factory.InitializingBean, org.springframework.beans.factory.DisposableBean
A Spring `FactoryBean` that builds and exposes a preconfigured `ForkJoinPool`.

Since:
  3.1
Author:
  Juergen Hoeller

## Field Summary

### Fields inherited from interface org.springframework.beans.factory.FactoryBean

`OBJECT_TYPE_ATTRIBUTE`

## Constructor Summary

Constructors
Constructor
Description
`ForkJoinPoolFactoryBean()`

## Method Summary

Modifier and Type
Method
Description
`void`
`afterPropertiesSet()`
`void`
`destroy()`
`ForkJoinPool`
`getObject()`
`Class<?>`
`getObjectType()`
`boolean`
`isSingleton()`
`void`
`setAsyncMode(boolean asyncMode)`
Specify whether to establish a local first-in-first-out scheduling mode for forked tasks that are never joined.
`void`
`setAwaitTerminationSeconds(int awaitTerminationSeconds)`
Set the maximum number of seconds that this ForkJoinPool is supposed to block on shutdown in order to wait for remaining tasks to complete their execution before the rest of the container continues to shut down.
`void`
`setCommonPool(boolean commonPool)`
Set whether to expose JDK 8's 'common' `ForkJoinPool`.
`void`
`setParallelism(int parallelism)`
Specify the parallelism level.
`void`
`setThreadFactory(ForkJoinPool.ForkJoinWorkerThreadFactory threadFactory)`
Set the factory for creating new ForkJoinWorkerThreads.
`void`
`setUncaughtExceptionHandler(Thread.UncaughtExceptionHandler uncaughtExceptionHandler)`
Set the handler for internal worker threads that terminate due to unrecoverable errors encountered while executing tasks.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ForkJoinPoolFactoryBean

public ForkJoinPoolFactoryBean()

## Method Details

### setCommonPool

public void setCommonPool(boolean commonPool)
Set whether to expose JDK 8's 'common' `ForkJoinPool`.

Default is "false", creating a local `ForkJoinPool` instance based on the `"parallelism"`, `"threadFactory"`, `"uncaughtExceptionHandler"` and `"asyncMode"` properties on this FactoryBean.

NOTE: Setting this flag to "true" effectively ignores all other properties on this FactoryBean, reusing the shared common JDK `ForkJoinPool` instead. This is a fine choice on JDK 8 but does remove the application's ability to customize ForkJoinPool behavior, in particular the use of custom threads.

Since:
  3.2
See Also:
  - `ForkJoinPool.commonPool()`

### setParallelism

public void setParallelism(int parallelism)
Specify the parallelism level. Default is `Runtime.availableProcessors()`.

### setThreadFactory

public void setThreadFactory(ForkJoinPool.ForkJoinWorkerThreadFactory threadFactory)
Set the factory for creating new ForkJoinWorkerThreads. Default is `ForkJoinPool.defaultForkJoinWorkerThreadFactory`.

### setUncaughtExceptionHandler

public void setUncaughtExceptionHandler(Thread.UncaughtExceptionHandler uncaughtExceptionHandler)
Set the handler for internal worker threads that terminate due to unrecoverable errors encountered while executing tasks. Default is none.

### setAsyncMode

public void setAsyncMode(boolean asyncMode)
Specify whether to establish a local first-in-first-out scheduling mode for forked tasks that are never joined. This mode (asyncMode = `true`) may be more appropriate than the default locally stack-based mode in applications in which worker threads only process event-style asynchronous tasks. Default is `false`.

### setAwaitTerminationSeconds

public void setAwaitTerminationSeconds(int awaitTerminationSeconds)
Set the maximum number of seconds that this ForkJoinPool is supposed to block on shutdown in order to wait for remaining tasks to complete their execution before the rest of the container continues to shut down. This is particularly useful if your remaining tasks are likely to need access to other resources that are also managed by the container.

By default, this ForkJoinPool won't wait for the termination of tasks at all. It will continue to fully execute all ongoing tasks as well as all remaining tasks in the queue, in parallel to the rest of the container shutting down. In contrast, if you specify an await-termination period using this property, this executor will wait for the given time (max) for the termination of tasks.

Note that this feature works for the `"commonPool"` mode as well. The underlying ForkJoinPool won't actually terminate in that case but will wait for all tasks to terminate.

See Also:
  - `ForkJoinPool.shutdown()`
  - `ForkJoinPool.awaitTermination(long, java.util.concurrent.TimeUnit)`

### afterPropertiesSet

public void afterPropertiesSet()

Specified by:
  `afterPropertiesSet` in interface `org.springframework.beans.factory.InitializingBean`

### getObject

@Nullable public ForkJoinPool getObject()

Specified by:
  `getObject` in interface `org.springframework.beans.factory.FactoryBean<ForkJoinPool>`

### getObjectType

public Class<?> getObjectType()

Specified by:
  `getObjectType` in interface `org.springframework.beans.factory.FactoryBean<ForkJoinPool>`

### isSingleton

public boolean isSingleton()

Specified by:
  `isSingleton` in interface `org.springframework.beans.factory.FactoryBean<ForkJoinPool>`

### destroy

public void destroy()

Specified by:
  `destroy` in interface `org.springframework.beans.factory.DisposableBean`